package org.beangle.model.pojo;

import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.beangle.model.predicates.ValidEntityKeyPredicate;

public class LongIdObject implements IdEntity<Long> {
	private static final long serialVersionUID = -7530111699332363124L;
	
	protected Long id;

	public LongIdObject() {
		super();
	}

	public LongIdObject(Long id) {
		super();
		this.id = id;
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String key() {
		return "id";
	}

	public boolean saved() {
		return ValidEntityKeyPredicate.INSTANCE.evaluate(id);
	}

	public boolean unsaved() {
		return !ValidEntityKeyPredicate.INSTANCE.evaluate(id);
	}

	/**
	 * @see java.lang.Object#hashCode()
	 */
	public int hashCode() {
		return new HashCodeBuilder(-64900959, -454788261).append(this.id).toHashCode();
	}

	/**
	 * 比较id,如果任一方id是null,则不相等
	 * 
	 * @see java.lang.Object#equals(Object)
	 */
	public boolean equals(final Object object) {
		if (!(object instanceof LongIdObject)) {
			return false;
		}
		LongIdObject rhs = (LongIdObject) object;
		if (null == getId() || null == rhs.getId()) {
			return false;
		}
		return new EqualsBuilder().append(this.getId(), rhs.getId()).isEquals();
	}
}
